#ifndef HART_SERIAL_H
#define HART_SERIAL_H

#include "hart_lib.h"

#define DELIM_PHYLAYER_ASYNC    0x00
#define DELIM_FRAME_BACK        0x01
#define DELIM_FRAME_STX         0x02
#define DELIM_FRAME_ACK         0x06

#define ADDR_POLING                     0
#define ADDR_UNIQUE                     1
#define EXPBYTES_MSK              0x60

#define ADDR_MSK                  0x80


//=========================== typedef =========================================

typedef void (*hart_serial_request_cbt)(uint16_t cmdId, uint8_t* payload, uint8_t len, hart_lib_master_t master);

//=========================== prototypes ======================================

void hart_serial_init(hart_serial_request_cbt requestCb, uint8_t* inputBuf, uint8_t inputBufLen);

// response format: RC|Data data
void hart_serial_txHartFrame(uint16_t cmd, uint8_t* response, uint8_t response_len);
void hart_serial_errorReply(uint8_t cmdId,uint8_t errCode);

#endif
