#ifndef HART_SETTINGS_H
#define HART_SETTINGS_H

// Communication status codes, HCF_SPEC-099,Table 10 
#define HART_ERR_COM           0x80
#define HART_ERR_PARITY        0x40
#define HART_ERR_OVERRUN       0x20
#define HART_ERR_FRAMING       0x10
#define HART_ERR_CHCKSUM       0x08
#define HART_ERR_COMMUNICATION 0x04
#define HART_ERR_BUFF_OVF      0x02
#define HART_ERR_NONE          0x00

//==== device variables
#define HART_MAX_DEV_VARS          4

#define HART_BURST_NUM             1
#define HART_EVENT_NUM             1

#define HART_MIN_RX_PREAMBLES          5
#define HART_MIN_TX_PREAMBLES          5

#endif
