#include "debug.h"

#include <stdarg.h>

#include "SEGGER_RTT.h"

//=========================== variables =======================================

debug_errors_t debug_errors;

struct __FILE
{
    int handle;
};

FILE __stdout;
FILE __stdin;


//=========================== public ==========================================
/*
int16_t debug_init(void)
{
#ifdef DEBUG
		int16_t err;
	
    // reset local variables
    memset(&debug_errors,   0, sizeof(debug_errors));

    // init RTT up buffer
    err = SEGGER_RTT_ConfigUpBuffer(0, NULL, NULL, 0, SEGGER_RTT_MODE_NO_BLOCK_TRIM);
	
		// send init MSG
		DEBUG_MSG(MSG_IDN);
	
		return  err;
#else
    return -1;
#endif
}
*/

int16_t DEBUG_MSG(const char* format, ...)
{
#ifdef DEBUG
    va_list arg;
    int16_t done;

    va_start( arg, format);
    done = vfprintf(stdout, format, arg);
    va_end (arg);

    return done;
#else
    return -1;
#endif

}
//=========================== fputc redirect =====================================

#ifdef DEBUG
int fputc(int ch, FILE * stream )
{
    SEGGER_RTT_Write(0, &ch, 1); /* use Segger RTT */

    return( ch);
}
#endif
